############## GIVEN
Given /^I have a todo$/ do
  @todo = FactoryGirl.create(:todo, user: @user)
end

Given /^I have another todo that is already done$/ do
  @other_todo = FactoryGirl.build(:todo, title: "Other Title")
  @other_todo.user = @user
  @other_todo.done = true
  @other_todo.save
end

Given /^someone else has a todo$/ do
  @other_todo = FactoryGirl.create(:todo, title: "Other Todo")
end

############## WHEN
When /^I try to look at the other todo$/ do
  visit todo_path(@other_todo)
end

When /^I go to the new todo page$/ do
  visit new_todo_path
end

When /^fill out the new todo form$/ do
  fill_in "Title", with: "My first Todo!"
  fill_in "Description", with: "Something I have to do,..."
  click_button "Create Todo"
end

Then /^I should be on the new created todo's show page$/ do
  page.should have_content("My first Todo!")
end

When /^fill out the form without a title$/ do
  click_button "Create Todo"
end

When /^I go to the todo list page$/ do
  visit todos_path
end

When /^click the link "(.*?)"$/ do |link_text|
  click_link link_text
end

When /^click the button "(.*?)"$/ do |button_text|
  click_button(button_text)
end

When /^go to the done page$/ do
  visit todos_path(done: true)
end

############## THEN
Then /^I should be redirected to my todo list$/ do
  current_url.should =~ /todos$/
end

Then /^I should see the other todo$/ do
  page.should have_content(@other_todo.title)
end

Then /^I still should see the new todo form$/ do
  page.should have_content("New Todo")
end

Then /^see an error message for the missing title$/ do
  page.should have_content("can't be blank")
end

Then /^the todo should have been added to my todo list$/ do
  @user.todos.should include(Todo.last)
end

Then /^the todo should have been added to my list$/ do
  page.should have_content(Todo.last.title)
end

Then /^I should see the todo$/ do
  page.should have_content(@todo.title)
end

Then /^I should not see the other todo$/ do
  page.should_not have_content(@other_todo.title)
end

Then /^I should just see the undone todo$/ do
  page.should have_content(@todo.title)
  page.should_not have_content(@other_todo.title)
end
